var UI = function(){
	this.question = $('#question');
	this.answers = [
		$("#answer-one"),
		$("#answer-two"),
		$("#answer-three")
	];
	this.player = $('#player');
	this.questionContainer = $("#question-container");
	this.startMenu = $("#player-select-menu");
	this.timerCounter = $("#counter-container");
	this.timerCounterTime = $("#counter-timer");
	this.playersCounterNumber = $("#players-counter-number");
	this.trafficLights = $("#semaforo");
	this.trafficLightsBG_A = "";
	this.trafficLightsBG_B = "";
	this.exitButton = $("#salir");
	this.multiplayerScores = $("#multiplayer-scores");
	this.onePlayerScores = $("#one-player-scores");
	this.onePlayerTotalScore = $("#one-player-total-score-screen");
	this.multiplayerPositionHTML = $("#pane-3").children("div .position-pane-element");
	
	this.overlay= $("#overlay");
	// Load the Buttons Visual Response Behaviours file
	this.loadJSFile("js/buttonsVisualBehaviours.js");
	this.init();
}

UI.prototype.init = function(){
	
}

UI.prototype.loadJSFile = function(url){
	var head = document.getElementsByTagName('head')[0];
    var buttonsScript = document.createElement('script');
    buttonsScript.type = 'text/javascript';
    buttonsScript.src = url;
	head.appendChild(buttonsScript);
}

UI.prototype.calculateSize = function(){
	// Add container margins when necessary	
	//$('#score-current-round').fitText(0.13)	
	$('#counter-container').fitText(0.3);
	$('#multiplayer-scores #pane-1').fitText(0.08);
	$('.score-pane-element').fitText(0.45);
	$('#n-jugadores-title-h').fitText(1.5, { minFontSize: '20px' });
	$('#one-player-scores .question-score').fitText(0.7);
	/* $('#multiplayer-scores #pane-1 span').fitText(0.4);
	$('#pane-2, #pane-3').fitText(0.3);
	$('#multiplayer-scores #player-turn-score').fitText(1.5, { minFontSize: '22px' }); */
}

UI.prototype.countDown = function(f){
	var self = this;
	this.hideStartMenu();
	this.initCounter = 3;
	setTimeout(function(){
		var interval = setInterval(function(){
			$('#player-counter').html("<h2 id='countdown'>" + self.initCounter + "</h2>");
			self.initCounter--;
			if(self.initCounter < 1){
				clearInterval(interval);

				self.startMenu.animate({
					opacity: 0
				}, 800, function(){
					self.startMenu.css("display", "none");
					self.questionContainer.css("display", "block");
					
				})
				setTimeout(function(){
					f();
				}, 1000)
				
				
				
			}
		}, 1000)
	}, 100)
}

UI.prototype.hideStartMenu = function(){
	$("#players-counter-number").animate({
		top: ["-156%"]
	}, 800);

	$("#counter-left-button").animate({
		top: ["-101%"]
	}, 800);
	
	$("#counter-right-button").animate({
		top: ["-101%"]
	}, 800);
		
	$("#init").animate({
		bottom: ["-22%"]
	}, 800);
	
	$("#n-jugadores-title-h").animate({
		opacity: ["0"]
	}, 400);
	
}

UI.prototype.drawQuestion = function(question){
	this.question.html(question);
}

UI.prototype.displayQuestion = function(){
	this.question.animate({
		top: [ "0px" ]
	  }, 500);
}

UI.prototype.hideQuestion = function(){

	this.question.animate({
		top: [ "-82px" ]
	  }, 500);
}

UI.prototype.drawAnswers = function(answers, f){
	for(a in answers){
		this.answers[a].html('<span class="answer-text">' + answers[a] + '</span>');
	}

	$('.answer-text').each(function(i,v){
		console.log($(v).width())
		$(v).css({
			position: 'absolute',
			top: '50%',
			left: '50%',
			width: '95%',
			marginLeft: -($(v).width() / 2),
			marginTop: -($(v).height() / 2),
		});
	})

	var self = this;
	
	self.answers[0].animate({
		left: [ "-5%","easeOutBack" ]
	},800);

	self.answers[1].animate({
		right: [ "5%","easeOutBack" ]
	}, 800);

	self.answers[2].animate({
		left: [ "-5%","easeOutBack" ]
	}, 800);

	setTimeout(function(){
		f();
	}, 600)
}

UI.prototype.hideAnswers = function(){
	this.answers[0].animate({
		left: [ "-171%" ]
	  }, 500);
	  
	this.answers[1].animate({
		right: [ "-171%" ]
	  }, 500);
	  
	this.answers[2].animate({
		left: [ "-171%" ]
	  }, 500);
}

UI.prototype.displayTimerCounter = function(){
	this.timerCounter.show();
	this.timerCounter.animate({
		bottom: [ "0%" ]
	  }, 500);
}

UI.prototype.hideTimerCounter = function(){
	this.timerCounter.animate({
		bottom: [ "-25%" ]
	  }, 500);
	  
	window.setTimeout(function(timerCounter){
		timerCounter.hide();
	}, 501, this.timerCounter);
}

UI.prototype.updateTimerCounter = function(time){
	this.timerCounterTime.empty().append(time);
}

UI.prototype.drawPlayer = function(n){
	this.player.html("Jugador " + n);
}

UI.prototype.displayPlayer = function(){
	this.player.animate({
		top: [ "0px" ]
	  }, 500);
}

UI.prototype.hidePlayer = function(){
	this.player.animate({
		top: [ "-80px" ]
	  }, 500);
}

UI.prototype.aspectResize = function(){
	/*var aspect = $('#container');
    var width = aspect.width();
    aspect.height(width/5*3);*/
}

UI.prototype.displayTrafficLights = function(answerGuessResult){
	if(answerGuessResult === true){
		this.trafficLightsBG_A = "img/preguntas_semaforo_verde.png";
		this.trafficLightsBG_B = "img/preguntas_semaforo_luzverde.png";
		
	} else if(answerGuessResult === false){
		this.trafficLightsBG_A = "img/preguntas_semaforo_rojo.png";
		this.trafficLightsBG_B = "img/preguntas_semaforo_luzroja.png";
	}
	this.trafficLights.css('src', this.trafficLightsBG_A);
	
	this.flashTrafficLights();
	
	this.trafficLights.css('display', "block");
	
	// slide the trafficLights into the displayed area
	this.trafficLights.animate({
		top: [ "52%", "easeOutBack" ]
	  }, 800);
}

UI.prototype.hideTrafficLights = function(){
	this.trafficLights.animate({
		top: [ "100%", "easeInBack" ]
	  }, 800);
}

UI.prototype.flashTrafficLights = function(){
	var self = this;
	var bgPath = "";
	var flashDelay = 250;
	var numberOfChanges = 6;
	
	for(i = 0; i < numberOfChanges; i++){
		if((i % 2 === 0) || (i === 0))
			bgPath = self.trafficLightsBG_B;
		else
			bgPath = self.trafficLightsBG_A;
		
		(function(flashDelay, bgPath, i){
			window.setTimeout(function(){
				self.trafficLights.attr("src", bgPath);
			}, flashDelay * (i+1));			
		})(flashDelay, bgPath, i);
	}
}

UI.prototype.displayExitButton = function(){
	this.exitButton.animate({
		top: [ "0" ],
		right: [ "0" ]
	  }, 500);
}

UI.prototype.hideExitButton = function(){
	this.exitButton.animate({
		top: [ "-25%" ],
		right: [ "-20%" ]
	  }, 500);
}

UI.prototype.displayTurnScore = function(players, rounds, playersByScore){
	var self = this;
	currentPlayer = players.current;
	
	// hide the previous UI (timer, etc...)
	this.hideAllUI();
	
	// Check which score screen to display according to the number of players
	if(players.number === 1){
		// update each question score html content
		$answerScores = currentPlayer.getScoresAll();
		$answerScoresHTML = this.onePlayerScores.find( ".score-pane-element" );
		for(var i = 0; i < $answerScores.length; i++){
			// set the float as a 0 decimal number
			$answerScore = $answerScores[i].toFixed(0);
			
			// enable the question score so that it is shown
			$answerScoresHTML.eq(i).show();
			
			// update the html element for each question score
			$answerScoresHTML.eq(i).find("span").empty().append($answerScore);
		}
	
		window.setTimeout(function(ui){
			this.ui.questionContainer.css("display", "none");
			this.ui.onePlayerScores.css("display", "block");
			this.ui.fixedPosition('pane-2', true, true);
			this.ui.fixedPosition('total-score-button', 0, true);
		}, 825, this.ui);
	}
	else
	{
		// We update the score panes information
		// we parse the current turn and total turns in the first Pane
		$roundsInfo =  this.multiplayerScores.find( "#score-current-round" ).html();
		$roundsInfo = $roundsInfo.replace("%cr", rounds.currentRound);
		$roundsInfo = $roundsInfo.replace("%tr", rounds.roundsNumber.toFixed(0));
		this.multiplayerScores.find( "#score-current-round" ).empty().append($roundsInfo);
		
		// update current player image
		$playerBgImage = "results_player1.png";
		switch(currentPlayer.number)
		{
			case 1:
				$playerBgImage = "results_player1.png";
			break;
			case 2:
				$playerBgImage = "results_player2.png";
			break;
			case 3:
				$playerBgImage = "results_player3.png";
			break;
			case 4:
				$playerBgImage = "results_player4.png";
			break;		
		}
		$("#score-current-player").css("background-image", "url(img/" + $playerBgImage + ")");
		
		// update each player question score html content
		$totalTurnScore = 0;
		$answerScores = currentPlayer.getScoresAll();
		$answerScoresHTML = this.multiplayerScores.find( "#turn-questions" ).children();
		for(var i = 0; i < $answerScores.length; i++){
			// set the float as a 0 decimal number
			$answerScore = $answerScores[i].toFixed(0);	
			
			// update the total turn score
			$totalTurnScore += parseInt($answerScore);
			
			// update the html element for each question score
			$answerScoresHTML.eq(i).find("span").empty().append($answerScore);
		}
		
		// update player's total turn score
		$("#player-turn-score").find("span").empty().append($totalTurnScore);
		
		// reset to the original players position list order
		$("#pane-3").empty().append(this.multiplayerPositionHTML);
		
		// update players score ordered list
		// leave only the html elements corresponding to the number of players
		for(i = players.number +1; i <= 4; i++) {
			$("#score-position-player" + i).remove()
		}
		
		// Show the players in order
		$scorePlayersList = $("#pane-3").children("div .position-pane-element"); // we need to have the original HTML of the players, since this function changes it at the end and it may be called more than once
		
		$displayedScorePlayersList = [players.number];
		for(i = 0; i < players.number; i++) {
			$displayedScorePlayersList[i] = $scorePlayersList.eq(playersByScore[i].player - 1);
		}
		
		$displayedScorePlayersList[0].addClass("score-position-1st");
		$("#pane-3").empty().append($displayedScorePlayersList); // this is changing the original formation
		
		window.setTimeout(function(ui){
			this.ui.questionContainer.css("display", "none");
			this.ui.multiplayerScores.css("display", "block");
			this.ui.fixedPosition('multiplayer-scores #continue-button', 0, true);
			var pane2 = $('#m-pane-2')
			var pane3 = $('#pane-3')
			
			var h = 376 / 253  * $('#pane-3').width();
			pane2.css('height', h);
			pane3.css('height', h);
			self.fixedPosition('pane-2-3', true, true)
			//self.fixedPosition('m-pane-2', false, true);
			//self.fixedPosition('pane-3', false, true);
		}, 825, this.ui);
	}
}

UI.prototype.hideTurnScore = function(players, displayQuestionsUI){
	this.questionContainer.css("display", "block");

	if(players.number === 1){
		this.onePlayerScores.css("display", "none");
	}
	else {
		this.multiplayerScores.css("display", "none");
		
		// Initialize the round info on pane 1
		$roundsInfo =  this.multiplayerScores.find( "#score-current-round" ).empty().append("Ronda %cr de %tr");
		
		// Initialize the round info on pane 3
		$displayedScorePlayersList[0].removeClass("score-position-1st");
		
		if(displayQuestionsUI){
			this.displayExitButton();
			this.displayPlayer();
			this.displayQuestion();
			this.displayTimerCounter();
		}	
	}
}

UI.prototype.displayPodium = function(players, playersByScore){
	this.hideTurnScore(false);
	$("#question-container").hide();
	$("#podium-screen").show();
	
	// leave only the html elements corresponding to the number of players
	for(i = players.number +1; i <= 4; i++) {
		$("#podium-place-" + i).remove()
	}
	
	// change the BG image of the elements displayed on the podium according to the scores
	$podiumPlayersList = $("#podium-display").children("div");
	$displayedPodiumPlayersList = [players.number];
	for(i = 0; i < players.number; i++) {
		$podiumPlayersList.eq(i).css("background-image", "url(img/winner_" +  playersByScore[i].player + ".png)");
	}
	this.fixedPosition('podium-continue-button', 0, true);
	this.fixedPosition('podium-display', true, true);
}

UI.prototype.hidePodium = function(){
	$("#podium-screen").hide();
	$("#logo").hide();
}

UI.prototype.displayOnePlayerTotalScore = function(totalScore){
	// Update the total score value
	$("#total-score-pane").find("span").empty().append(totalScore.toFixed(0));
	
	// Display the screen
	$("#question-container").hide();
	this.onePlayerTotalScore.show();
	this.fixedPosition('total-score-pane', true, true);
	this.fixedPosition('one-player-total-score-screen #continue-button', 0, true);
}

UI.prototype.hideOnePlayerTotalScore = function(){
	this.hideAllUI();
	this.onePlayerTotalScore.hide();
}

UI.prototype.hideAllUI = function(){
	this.hideTrafficLights();
	this.hideAnswers();
	//this.hideExitButton();
	this.hidePlayer();
	this.hideQuestion();
	this.hideTimerCounter();
}

UI.prototype.displayAllUI = function(){
	this.displayTrafficLights();
	this.displayAnswers();
	//this.displayExitButton();
	this.displayPlayer();
	this.displayQuestion();
	this.displayTimerCounter();
}


UI.prototype.showExitPrompt = function(){
	this.setOverlay(true)
	$('#exit-prompt').css({
		display: 'block',
		top: '50%',
		left: '50%',
		marginLeft: -($('#exit-prompt').width() / 2),
		marginTop: -($('#exit-prompt').height() / 2),
	});

}

UI.prototype.hideExitPrompt = function(){
	this.setOverlay(false)
	$('#exit-prompt').css('display', 'none')
}

UI.prototype.setOverlay = function(on){
	if(on){
		this.overlay.css('display', 'block')
	}else{
		this.overlay.css('display', 'none')
	}
}

UI.prototype.fixedPosition = function(id, right, bottom){
	var el = $('#' + id)
	el.css({
		position: 'absolute',
		top: (bottom === true) ? '100%' : bottom, 
		left: (right === true) ? '100%' : right,
	});

	if(right === true){
		ml = - el.width()
		el.css('margin-left', ml)
	}
	if(bottom === true){
		mt = - el.height()
		el.css('margin-top', mt)
	}
}